/** @file HL_sys_main.c 
*   @brief Application main file
*   @date 11-Dec-2018
*   @version 04.07.01
*
*   This file contains an empty main function,
*   which can be used for the application.
*/

/* 
* Copyright (C) 2009-2018 Texas Instruments Incorporated - www.ti.com  
* 
* 
*  Redistribution and use in source and binary forms, with or without 
*  modification, are permitted provided that the following conditions 
*  are met:
*
*    Redistributions of source code must retain the above copyright 
*    notice, this list of conditions and the following disclaimer.
*
*    Redistributions in binary form must reproduce the above copyright
*    notice, this list of conditions and the following disclaimer in the 
*    documentation and/or other materials provided with the   
*    distribution.
*
*    Neither the name of Texas Instruments Incorporated nor the names of
*    its contributors may be used to endorse or promote products derived
*    from this software without specific prior written permission.
*
*  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
*  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
*  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
*  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
*  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
*  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
*  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
*  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
*  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
*  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
*  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*
*/


/* USER CODE BEGIN (0) */
#include "HL_i2c.h"
/* USER CODE END */

/* Include Files */

#include "HL_sys_common.h"

/* USER CODE BEGIN (1) */
/* USER CODE END */

/** @fn void main(void)
*   @brief Application main function
*   @note This function is empty by default.
*
*   This function is called after startup.
*   The user can use this function to implement the application.
*/

/* USER CODE BEGIN (2) */
#define SLAVE_ADDRESS1   0x57
#define SLAVE_ADDRESS2   0x58
#define SLAVE_ADDRESS3   0x59

uint8_t TX_Data_Master[1] = {0x10};
/* USER CODE END */

int main(void)
{
/* USER CODE BEGIN (3) */
        uint8_t slave_number=1;
        uint8_t NACK1=0,NACK2=0,NACK3=0 ;

        i2cInit();

        while(1)
        {
        switch(slave_number)
        {

            case 1:
            {
                  /* Configure address of Slave to talk to */
                  i2cSetSlaveAdd(i2cREG1, SLAVE_ADDRESS1);

                  /* Set direction to Transmitter */
                  /* Note: Optional - It is done in Init */
                  i2cSetDirection(i2cREG1, I2C_TRANSMITTER);

                  /* Configure Data count */
                  /* Data Count + 1 ( Word Address) */
                  i2cSetCount(i2cREG1, 1);

                  /* Set mode as Master */
                  i2cSetMode(i2cREG1, I2C_MASTER);

                  /* Set Stop after programmed Count */
                  i2cSetStop(i2cREG1);

                  /* Transmit Start Condition */
                  i2cSetStart(i2cREG1);

                  /* Send the Word Address */
                  i2cSendByte(i2cREG1, TX_Data_Master[0]);

                  /* Tranmit DATA_COUNT number of data in Polling mode */
                  //i2cSend(i2cREG1, 1, TX_Data_Master);

                  /* Wait until Bus Busy is cleared */
                  while(i2cIsBusBusy(i2cREG1) == true)
                  {
                      if((i2cREG1->STR & I2C_NACK) == I2C_NACK)
                      {
                            NACK1=0xFF;
                            break;  /*break while loop*/
                      }
                  }
                  /* Wait until Stop is detected */
                  while(i2cIsStopDetected(i2cREG1) == 0)
                  {
                      if((i2cREG1->STR & I2C_NACK) == I2C_NACK)
                      {
                            NACK1=0xFF;
                            break;  /*break while loop*/
                      }
                  }
                  if(NACK1 == 0xFF)
                  {
                      /*NACK is received due to slave not connected, So go to the next slave*/
                      NACK1 = 0x00;
                      slave_number =2;
                      i2cREG1->MDR = (uint32)((uint32)0U << 5U);/** - i2c Enter reset */
                      i2cREG1->MDR |= (uint32)I2C_RESET_OUT; /* i2c out of reset */
                      break;

                  }
                  /*Do additional operation if required as slave is connected*/
                  slave_number =2;
                  break;
            }
            case 2:
            {
                /* Configure address of Slave to talk to */
                i2cSetSlaveAdd(i2cREG1, SLAVE_ADDRESS2);

                /* Set direction to Transmitter */
                /* Note: Optional - It is done in Init */
                i2cSetDirection(i2cREG1, I2C_TRANSMITTER);

                /* Configure Data count */
                /* Data Count + 1 ( Word Address) */
                i2cSetCount(i2cREG1, 1);

                /* Set mode as Master */
                i2cSetMode(i2cREG1, I2C_MASTER);

                /* Set Stop after programmed Count */
                i2cSetStop(i2cREG1);

                /* Transmit Start Condition */
                i2cSetStart(i2cREG1);

                /* Send the Word Address */
                i2cSendByte(i2cREG1, TX_Data_Master[0]);

                /* Wait until Bus Busy is cleared */
                  while(i2cIsBusBusy(i2cREG1) == true)
                  {
                      if((i2cREG1->STR & I2C_NACK) == I2C_NACK)
                      {
                            NACK2=0xFF;
                            break;  /*break while loop*/
                      }
                  }
                  /* Wait until Stop is detected */
                  while(i2cIsStopDetected(i2cREG1) == 0)
                  {
                      if((i2cREG1->STR & I2C_NACK) == I2C_NACK)
                      {
                            NACK2=0xFF;
                            break;  /*break while loop*/
                      }
                  }
                  if(NACK2 == 0xFF)
                  {
                      /*NACK is received due to slave not connected, So go to the next slave*/
                      NACK2 = 0x00;
                      slave_number =3;
                      i2cREG1->MDR = (uint32)((uint32)0U << 5U);/** - i2c Enter reset */
                      i2cREG1->MDR |= (uint32)I2C_RESET_OUT; /* i2c out of reset */
                      break;

                  }
                  /*Do additional operation if required as slave is connected*/
                  slave_number =3;
                  break;

            }
            case 3:
           {
               /* Configure address of Slave to talk to */
               i2cSetSlaveAdd(i2cREG1, SLAVE_ADDRESS3);

               /* Set direction to Transmitter */
               /* Note: Optional - It is done in Init */
               i2cSetDirection(i2cREG1, I2C_TRANSMITTER);

               /* Configure Data count */
               /* Data Count + 1 ( Word Address) */
               i2cSetCount(i2cREG1, 1);

               /* Set mode as Master */
               i2cSetMode(i2cREG1, I2C_MASTER);

               /* Set Stop after programmed Count */
               i2cSetStop(i2cREG1);

               /* Transmit Start Condition */
               i2cSetStart(i2cREG1);

               /* Send the Word Address */
               i2cSendByte(i2cREG1, TX_Data_Master[0]);

               /* Wait until Bus Busy is cleared */
                 while(i2cIsBusBusy(i2cREG1) == true)
                 {
                     if((i2cREG1->STR & I2C_NACK) == I2C_NACK)
                     {
                           NACK3=0xFF;
                           break;  /*break while loop*/
                     }
                 }
                 /* Wait until Stop is detected */
                 while(i2cIsStopDetected(i2cREG1) == 0)
                 {
                     if((i2cREG1->STR & I2C_NACK) == I2C_NACK)
                     {
                           NACK3=0xFF;
                           break;  /*break while loop*/
                     }
                 }
                 if(NACK3 == 0xFF)
                 {
                     /*NACK is received due to slave not connected, So go to the next slave*/
                     NACK3 = 0x00;
                     slave_number =1;
                     i2cREG1->MDR = (uint32)((uint32)0U << 5U);/** - i2c Enter reset */
                     i2cREG1->MDR |= (uint32)I2C_RESET_OUT; /* i2c out of reset */
                     break;

                 }
                 /*Do additional operation if required as slave is connected*/
                 slave_number =1;
                 break;

           }
            default:
                break;

        }
        }

/* USER CODE END */

    return 0;
}


/* USER CODE BEGIN (4) */
/* USER CODE END */
